Attribute VB_Name = "FFXIFunctions"
Option Explicit
Const msRealDay = 86400000
Const vLocalTime = 1117359360000#
Const msGameDay = 3456000
Const msGameHour = 144000
Const msGameMinute = 2400
Const msGameSec = 2.4
Const MSPSec = 1000
Const SecPMin = 60
Const MinPHour = 60
Const HourPDay = 24
Const DayPEWeek = 7
Const DayPVWeek = 8
Const DayPVMon = 30
Const MonPYear = 12
Const DayPVYear = 360
Const MoonPhaseMod = 84
Const TavernMod = 25
Const VanaToEarth = 25
Const SelbinaMhaura = 28800000
Const ConquestUpdate = 604800000
Const RSEDelay = 691200000
Const olCreateAppointment = 1

Public Function Clvl(MainLevel As Integer, Ltr As String) As Integer
If Ltr = "-" Then Clvl = 0
If MainLevel <= 50 Then
    If Ltr = "A+" Then Clvl = Int(((MainLevel - 1) * 3) + 6)
        If Ltr = "A-" Then Clvl = Int(((MainLevel - 1) * 3) + 6)
        If Ltr = "B+" Then Clvl = Int((MainLevel - 1) * 2.9 + 5)
        If Ltr = "B" Then Clvl = Int((MainLevel - 1) * 2.9 + 5)
        If Ltr = "B-" Then Clvl = Int((MainLevel - 1) * 2.9 + 5)
        If Ltr = "C+" Then Clvl = Int((MainLevel - 1) * 2.8 + 5)
        If Ltr = "C" Then Clvl = Int((MainLevel - 1) * 2.8 + 5)
        If Ltr = "C-" Then Clvl = Int((MainLevel - 1) * 2.8 + 5)
        If Ltr = "D" Then Clvl = Int((MainLevel - 1) * 2.7 + 4)
        If Ltr = "E" Then Clvl = Int((MainLevel - 1) * 2.5 + 4)
        If Ltr = "F" Then Clvl = Int((MainLevel - 1) * 2.3 + 4)
ElseIf MainLevel <= 60 Then
    If Ltr = "A+" Then Clvl = Int((MainLevel - 50) * 5 + 153)
        If Ltr = "A-" Then Clvl = Int((MainLevel - 50) * 5 + 153)
        If Ltr = "B+" Then Clvl = Int((MainLevel - 50) * 4.9 + 147)
        If Ltr = "B" Then Clvl = Int((MainLevel - 50) * 4.9 + 147)
        If Ltr = "B-" Then Clvl = Int((MainLevel - 50) * 4.9 + 147)
        If Ltr = "C+" Then Clvl = Int((MainLevel - 50) * 4.8 + 142)
        If Ltr = "C" Then Clvl = Int((MainLevel - 50) * 4.8 + 142)
        If Ltr = "C-" Then Clvl = Int((MainLevel - 50) * 4.8 + 142)
        If Ltr = "D" Then Clvl = Int((MainLevel - 50) * 4.7 + 136)
        If Ltr = "E" Then Clvl = Int((MainLevel - 50) * 4.5 + 126)
        If Ltr = "F" Then Clvl = Int((MainLevel - 50) * 4.3 + 116)
Else
    If Ltr = "A+" Then Clvl = Int((MainLevel - 60) * 4.85 + 203)
        If Ltr = "A-" Then Clvl = Int((MainLevel - 60) * 4.85 + 203)
        If Ltr = "B+" Then Clvl = Int((MainLevel - 60) * 3.7 + 196)
        If Ltr = "B" Then Clvl = Int((MainLevel - 60) * 3.23 + 196)
        If Ltr = "B-" Then Clvl = Int((MainLevel - 60) * 2.7 + 196)
        If Ltr = "C+" Then Clvl = Int((MainLevel - 60) * 2.5 + 190)
        If Ltr = "C" Then Clvl = Int((MainLevel - 60) * 2.25 + 190)
        If Ltr = "C-" Then Clvl = Int((MainLevel - 60) * 2 + 190)
        If Ltr = "D" Then Clvl = Int((MainLevel - 60) * 1.85 + 183)
        If Ltr = "E" Then Clvl = Int((MainLevel - 60) * 1.9 + 171)
        If Ltr = "F" Then Clvl = Int((MainLevel - 60) * 2 + 159)

End If

End Function

Public Function formatCountdown(varTime As Double) As String
Dim dayLeft As Double, hourLeft As Double, minLeft As Double, secLeft As Double
Dim TdayLeft As String, ThourLeft As String, tMinLeft As String, tSecLeft As String
Dim formattedTime As String

dayLeft = varTime / msRealDay
hourLeft = (dayLeft - Int(dayLeft)) * 24
minLeft = (hourLeft - Int(hourLeft)) * 60
secLeft = Int((minLeft - Int(minLeft)) * 60)
formattedTime = ""

dayLeft = Int(dayLeft)
hourLeft = Int(hourLeft)
minLeft = Int(minLeft)

If dayLeft < 10 Then TdayLeft = "0" & dayLeft Else TdayLeft = dayLeft
If minLeft < 10 Then tMinLeft = "0" & minLeft Else tMinLeft = minLeft
If secLeft < 10 Then tSecLeft = "0" & secLeft Else tSecLeft = secLeft
If hourLeft < 10 Then ThourLeft = "0" & hourLeft Else ThourLeft = hourLeft

If dayLeft > 0 Then
    formattedTime = TdayLeft & ":" & ThourLeft & ":"
ElseIf hourLeft > 0 Then
    formattedTime = ThourLeft & ":"
End If

formatCountdown = formattedTime & tMinLeft & ":" & tSecLeft


End Function

Public Function VDayName(n1 As Integer) As String
Dim vDname
'                 0            1              2          3           4          5               6            7
vDname = Array("Firesday", "Earthsday", "Watersday", "Windsday", "Iceday", "Lightningday", "Lightsday", "Darksday")
VDayName = vDname(n1)
End Function

Public Function VDayColor(n1 As Integer) As ColorConstants
Dim vDcolor
vDcolor = Array(vbRed, vbYellow, vbBlue, vbGreen, vbCyan, vbMagenta, vbWhite, vbBlack)
VDayColor = vDcolor(n1)
End Function

Public Function WeakMagic(n1 As Integer) As String
Dim wkMagic
wkMagic = Array("Ice", "Lightning", "Fire", "Earth", "Wind", "Water", "Darkness", "Light")
WeakMagic = wkMagic(n1)
End Function
Public Function WeakColor(n1 As Integer) As ColorConstants
Dim wkColor
wkColor = Array(vbCyan, vbMagenta, vbRed, vbYellow, vbGreen, vbBlue, vbBlack, vbWhite)
WeakColor = wkColor(n1)
End Function

Public Function PhaseName(n1 As Integer) As String
Dim phName
phName = Array("Full Moon", "Waning Gibbous", "Last Quarter", "Waning Crescent", "New Moon", "Waxing Crescent", "First Quarter", "Waxing Gibbous")
PhaseName = phName(n1)
End Function
Public Function CalculateDelay(TheDelay) As String
Dim TheDelayHour As Integer, TheDelayMin As Integer, TheDelaySec As Integer
Dim DelayString As String
TheDelay = TheDelay / VanaToEarth
TheDelayHour = Int((TheDelay / MSPSec) / (SecPMin * MinPHour))
TheDelay = TheDelay - (TheDelayHour * MSPSec * SecPMin * MinPHour)
TheDelayMin = Int((TheDelay / MSPSec) / SecPMin)
TheDelay = TheDelay - (TheDelayMin * MSPSec * SecPMin)
TheDelaySec = Int(TheDelay / MSPSec)

If TheDelayHour > 0 Then DelayString = TheDelayHour & ":"
If TheDelayMin < 10 Then DelayString = DelayString & "0" & TheDelayMin Else DelayString = DelayString & TheDelayMin
DelayString = DelayString & ":"
If TheDelaySec < 10 Then DelayString = DelayString & "0" & TheDelaySec Else DelayString = DelayString & TheDelaySec

CalculateDelay = DelayString

End Function

Private Function CalculateEarthTime(CurrentTime As Date, ShowYear As Boolean, ShowSeconds As Boolean) As String
Dim eYear As Integer, eMon As Integer, eDate As Integer, eHour As Integer, eMin As Integer, eSec As Integer
Dim TeYear As String, TeMon As String, TeDate  As String, TeHour  As String, TeMin  As String, TeSec  As String
Dim eString As String
eYear = Year(CurrentTime)
eMon = Month(CurrentTime)
eDate = Day(CurrentTime)
eHour = Hour(CurrentTime)
eMin = Minute(CurrentTime)
eSec = Second(CurrentTime)

If eYear < 10 Then TeYear = "0" & eYear Else TeYear = eYear
If eDate < 10 Then TeDate = "0" & eDate Else TeDate = eDate
If eHour < 10 Then TeHour = "0" & eHour Else TeHour = eHour
If eMin < 10 Then TeMin = "0" & eMin Else TeMin = eMin
If eSec < 10 Then TeSec = "0" & eSec Else TeSec = eSec
If eMon < 10 Then TeMon = "0" & eMon Else TeMon = eMon
eString = TeMon & "/" & TeDate
If ShowYear = True Then eString = eString & "/" & TeYear
eString = eString & " " & TeHour & ":" & TeMin
If ShowSeconds = True Then eString = eString & ":" & TeSec
CalculateEarthTime = eString


End Function

Public Function CalculateMoonPhase(CurrentTime) As String
Dim vMoon As Integer, MooYa As Double
MooYa = CurrentTime / msRealDay
vMoon = Round((Abs(((Int(MooYa) + 26) Mod MoonPhaseMod) - (MoonPhaseMod / 2)) / (MoonPhaseMod / 2)) * 100)
    If (vMoon > 10) And (vMoon < 90) Then
        CalculateMoonPhase = vMoon & "%"
    ElseIf (vMoon >= 90) Then
        CalculateMoonPhase = vMoon & "%(Full)"
    ElseIf (vMoon <= 10) Then
        CalculateMoonPhase = vMoon & "%(New)"
    End If
    
End Function


Public Function TimeLeftFormat(h, m, s) As String
Dim msLeftInGameDay As Double
Dim minLeft As Integer, secLeft As Integer
Dim tMinLeft As String, tSecLeft As String
Dim futTime As Date

msLeftInGameDay = msGameDay - ((h * msGameHour) + (m * msGameMinute) + (s * msGameSec))
minLeft = Int(msLeftInGameDay / 1000 / 60)
secLeft = Int(msLeftInGameDay / 1000) Mod 60

If minLeft < 10 Then tMinLeft = "0" & minLeft Else tMinLeft = minLeft
If secLeft < 10 Then tSecLeft = "0" & secLeft Else tSecLeft = secLeft

futTime = DateAdd("n", minLeft, Now)
futTime = DateAdd("s", secLeft, futTime)

TimeLeftFormat = tMinLeft & ":" & tSecLeft & " (" & FormatDateTime(futTime, vbShortTime) & ")"

End Function



Public Function cVyear(msTime) As Integer
cVyear = Int(msTime / (DayPVYear * msRealDay))
End Function
Public Function cVmon(msTime) As Integer
cVmon = Int(((msTime / (DayPVMon * msRealDay))) - (Int((msTime / (DayPVMon * msRealDay)) / MonPYear) * MonPYear)) + 1
End Function
Public Function cVanadate(msTime) As Integer
cVanadate = Int((msTime / (msRealDay)) - (Int((msTime / (msRealDay)) / DayPVMon) * DayPVMon)) + 1
End Function
Public Function cVhour(msTime) As Integer
cVhour = Int((msTime / (MinPHour * SecPMin * MSPSec)) - (Int((msTime / (MinPHour * SecPMin * MSPSec)) / HourPDay) * HourPDay))
End Function
Public Function cVmin(msTime) As Integer
cVmin = Int((msTime / (SecPMin * MSPSec)) - (Int((msTime / (SecPMin * MSPSec)) / MinPHour) * MinPHour))
End Function
Public Function cVsec(msTime) As Integer
cVsec = Int((msTime / (MSPSec)) - (Int((msTime / (MSPSec)) / SecPMin) * SecPMin))
End Function
Public Function cVday(msTime) As Integer
cVday = Int((msTime / (msRealDay)) - (Int((msTime / (msRealDay)) / DayPVWeek) * DayPVWeek))
End Function



Public Sub NewAppt(sSubject As String, sLoc As String, sBody As String, dStart As Date, dEnd As Date, Minreminder As Integer)
Dim pOLA As PocketOutlook.Application
Dim pApptItem As PocketOutlook.AppointmentItem
Set pOLA = CreateObject("PocketOutlook.Application")
pOLA.Logon (Form1.hWnd)
Set pApptItem = pOLA.CreateItem(olCreateAppointment)
pApptItem.Subject = sSubject
pApptItem.Location = sLoc
pApptItem.Body = sBody
pApptItem.Start = dStart
pApptItem.End = dEnd
pApptItem.Categories = "FFXI"
pApptItem.ReminderSet = Minreminder

pApptItem.Save
pApptItem.Display
pApptItem.AddRef
Set pApptItem = Nothing
pOLA.Logoff
Set pOLA = Nothing
End Sub
Public Function BigMod(num, num2) As Integer
BigMod = num - (Int(num / num2) * num2)

End Function

